Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/FilterView.Designer.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/FilterView.Designer.cs	(revision 11043)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/FilterView.Designer.cs	(revision 11044)
@@ -34,6 +34,6 @@
       this.lblPercentage = new System.Windows.Forms.Label();
       this.tbPercentage = new System.Windows.Forms.TextBox();
-      this.tbFiltered = new System.Windows.Forms.TextBox();
-      this.lblFiltered = new System.Windows.Forms.Label();
+      this.tbRemaining = new System.Windows.Forms.TextBox();
+      this.lblRemaining = new System.Windows.Forms.Label();
       this.tbTotal = new System.Windows.Forms.TextBox();
       this.lblTotal = new System.Windows.Forms.Label();
@@ -81,6 +81,6 @@
       this.groupBoxFilterInfo.Controls.Add(this.lblPercentage);
       this.groupBoxFilterInfo.Controls.Add(this.tbPercentage);
-      this.groupBoxFilterInfo.Controls.Add(this.tbFiltered);
-      this.groupBoxFilterInfo.Controls.Add(this.lblFiltered);
+      this.groupBoxFilterInfo.Controls.Add(this.tbRemaining);
+      this.groupBoxFilterInfo.Controls.Add(this.lblRemaining);
       this.groupBoxFilterInfo.Controls.Add(this.tbTotal);
       this.groupBoxFilterInfo.Controls.Add(this.lblTotal);
@@ -113,20 +113,20 @@
       // tbFiltered
       // 
-      this.tbFiltered.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.tbFiltered.Enabled = false;
-      this.tbFiltered.Location = new System.Drawing.Point(104, 45);
-      this.tbFiltered.Name = "tbFiltered";
-      this.tbFiltered.Size = new System.Drawing.Size(549, 20);
-      this.tbFiltered.TabIndex = 9;
+      this.tbRemaining.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.tbRemaining.Enabled = false;
+      this.tbRemaining.Location = new System.Drawing.Point(104, 45);
+      this.tbRemaining.Name = "tbRemaining";
+      this.tbRemaining.Size = new System.Drawing.Size(549, 20);
+      this.tbRemaining.TabIndex = 9;
       // 
       // lblFiltered
       // 
-      this.lblFiltered.AutoSize = true;
-      this.lblFiltered.Location = new System.Drawing.Point(15, 47);
-      this.lblFiltered.Name = "lblFiltered";
-      this.lblFiltered.Size = new System.Drawing.Size(44, 13);
-      this.lblFiltered.TabIndex = 8;
-      this.lblFiltered.Text = "Filtered:";
+      this.lblRemaining.AutoSize = true;
+      this.lblRemaining.Location = new System.Drawing.Point(15, 47);
+      this.lblRemaining.Name = "lblRemaining";
+      this.lblRemaining.Size = new System.Drawing.Size(60, 13);
+      this.lblRemaining.TabIndex = 8;
+      this.lblRemaining.Text = "Remaining:";
       // 
       // tbTotal
@@ -276,6 +276,6 @@
     private System.Windows.Forms.Label lblPercentage;
     private System.Windows.Forms.TextBox tbPercentage;
-    private System.Windows.Forms.TextBox tbFiltered;
-    private System.Windows.Forms.Label lblFiltered;
+    private System.Windows.Forms.TextBox tbRemaining;
+    private System.Windows.Forms.Label lblRemaining;
     private System.Windows.Forms.RadioButton rBtnOr;
     private System.Windows.Forms.RadioButton rBtnAnd;
Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/FilterView.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/FilterView.cs	(revision 11043)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.4/FilterView.cs	(revision 11044)
@@ -18,5 +18,5 @@
       InitializeComponent();
       tbTotal.Text = "0";
-      tbFiltered.Text = "0";
+      tbRemaining.Text = "0";
       tbPercentage.Text = "0%";
     }
@@ -65,7 +65,7 @@
         bool[] result = Content.FilterLogic.Preview(filters, rBtnAnd.Checked);
 
-        int filteredCnt = result.Count(c => c);
+        int filteredCnt = result.Count(c => !c);
 
-        tbFiltered.Text = filteredCnt.ToString();
+        tbRemaining.Text = filteredCnt.ToString();
         double percentage = result.Length == 0 ? 0.0 : filteredCnt * 100 / (double)result.Length;
         tbPercentage.Text = String.Format("{0:0.0000}%", percentage);